<?php

class DispletRetsIdxSearchResults{
	public function replace_page_content($content) {
		// Retrieve options from settings page
		$displet_rets_idx_option = DispletRetsIdxSettings::get_option();
		
		$page_id = $displet_rets_idx_option['displet_rets_idx_option_search_results_page_id'];
		global $wp_query;
		$property_id = get_query_var('property_id');
		$property_zip = get_query_var('property_zip');
		$property_city = get_query_var('property_city');
		$property_state = get_query_var('property_state');
		if (is_page($page_id) && empty($property_id) && empty($property_zip) && empty($property_city) && empty($property_state)) {
			$model = array(
				'region' => stripslashes($displet_rets_idx_option['displet_rets_idx_option_oodle_region']),
				'category' => stripslashes($displet_rets_idx_option['displet_rets_idx_option_oodle_category']),
				'orientation' => stripslashes($displet_rets_idx_option['displet_rets_idx_option_listings_orientation']),
				'default_sort' => stripslashes($displet_rets_idx_option['displet_rets_idx_option_listings_sort']),
				'sort_by' => stripslashes($displet_rets_idx_option['displet_rets_idx_option_sort_by']),
				'sort_order' => stripslashes($displet_rets_idx_option['displet_rets_idx_option_sort_order']),
				'is_displet_api' => (!empty($displet_rets_idx_option['displet_rets_idx_option_displet_app_key'])) ? true : false,
				'map_variance' => stripslashes($displet_rets_idx_option['displet_rets_idx_option_map_variance']),
				'return_fields' => 'city,full_baths,half_baths,image_urls,internet_remarks,latitude,list_price,listing_office_name,longitude,mls_number,num_bedrooms,property_type,square_feet,state,street_name,street_number,street_post_dir,street_pre_dir,subdivision,sysid,zip',
				'previous_page_url' => '#prev',
				'next_page_url' => '#next'
			);
	
			// Get query from $model
			$model['query_url'] = DispletRetsIdxQuery::get_query_url($model);
	
			// Get listings server-side to pass to templates for crawlable content
			$listings = DispletRetsIdxQuery::get_listings($model);
			$model = array_merge($model, $listings);
	
			$content = DispletRetsIdxLoad::get_template('displet-search-results-jquery.php', $model);
			$content .= DispletRetsIdxLoad::get_template('displet-map-jquery.php', $model);
			$content .= DispletRetsIdxLoad::get_template('displet-search-form.php', $model);
			$content .= DispletRetsIdxLoad::get_template('displet-dynamic.php', $model);
		}
		return $content;
	}

	function update_user_hash(){
		// Check nonce for security
		check_ajax_referer('displet_update_user_hash_nonce');
		
		if (isset($_POST['action']) && $_POST['action'] == 'displet_update_user_hash' && is_user_logged_in()){
			$user = wp_get_current_user();
			update_user_meta($user->ID, 'displet_last_hash', $_POST['last_hash']);
		}
		die();
	}
}

add_filter('the_content', array('DispletRetsIdxSearchResults', 'replace_page_content'));
add_action('wp_ajax_displet_update_user_hash', array('DispletRetsIdxSearchResults', 'update_user_hash'));
add_action('wp_ajax_nopriv_displet_update_user_hash', array('DispletRetsIdxSearchResults', 'update_user_hash'));

?>