<?php

class DispletRetsIdxUrlStructure{
	function create_global_model() {
		$displet_rets_idx_option = DispletRetsIdxSettings::get_option();
		$page_id = $displet_rets_idx_option['displet_rets_idx_option_property_details_page_id'];
		if (is_page($page_id)) {
			global $displet_rets_idx_global_model;
			$displet_rets_idx_global_model = array(
				'is_displet_api' => (!empty($displet_rets_idx_option['displet_rets_idx_option_displet_app_key'])) ? true : false,
				'app_key' => $displet_rets_idx_option['displet_rets_idx_option_displet_app_key'],
				'color_scheme' => $displet_rets_idx_option['displet_rets_idx_option_color_scheme'],
				'property_id' => get_query_var('property_id'),
				'property_zip' => get_query_var('property_zip'),
				'property_city' => get_query_var('property_city'),
				'property_state' => get_query_var('property_state'),
				'page_id' => $page_id
			);
			if (!empty($displet_rets_idx_global_model['property_id'])) {
				$displet_rets_idx_global_model['facebook_app_id'] = $displet_rets_idx_option['displet_rets_idx_option_facebook_app_id'];
				$displet_rets_idx_global_model['google_auth_url'] = DispletRetsIdxGoogle::get_authorization_url();
				// Get raw data from json API server-side for crawlable content - creating global to only ping API once and use the data across various WP hooks
				$listing = DispletRetsIdxQuery::get_listing($displet_rets_idx_global_model);
				$displet_rets_idx_global_model = array_merge($displet_rets_idx_global_model, $listing);
			}
			else {
				if (!empty($displet_rets_idx_global_model['property_state']) || !empty($displet_rets_idx_global_model['property_city']) || !empty($displet_rets_idx_global_model['property_zip'])) {
					$displet_rets_idx_global_model['map_variance'] = stripslashes($displet_rets_idx_option['displet_rets_idx_option_map_variance']);
					$displet_rets_idx_global_model['region'] = stripslashes($displet_rets_idx_option['displet_rets_idx_option_oodle_region']);
					$displet_rets_idx_global_model['category'] = stripslashes($displet_rets_idx_option['displet_rets_idx_option_oodle_category']);
					$displet_rets_idx_global_model['listings_per_page'] = intval($displet_rets_idx_option['displet_rets_idx_option_listings_per_page']);
					$displet_rets_idx_global_model['orientation'] = stripslashes($displet_rets_idx_option['displet_rets_idx_option_listings_orientation']);
					$displet_rets_idx_global_model['default_sort'] = stripslashes($displet_rets_idx_option['displet_rets_idx_option_listings_sort']);
					$displet_rets_idx_global_model['sort_by'] = stripslashes($displet_rets_idx_option['displet_rets_idx_option_sort_by']);
					$displet_rets_idx_global_model['sort_order'] = stripslashes($displet_rets_idx_option['displet_rets_idx_option_sort_order']);
					$displet_rets_idx_global_model['return_fields'] = 'city,full_baths,half_baths,image_urls,internet_remarks,latitude,list_price,listing_office_name,longitude,mls_number,num_bedrooms,property_type,square_feet,state,street_name,street_number,street_post_dir,street_pre_dir,subdivision,sysid,zip';
					$displet_rets_idx_global_model['previous_page_url'] = '#prev';
					$displet_rets_idx_global_model['next_page_url'] = '#next';
					if (!empty($displet_rets_idx_global_model['property_zip'])){
						$displet_rets_idx_global_model['zip'] = $displet_rets_idx_global_model['property_zip'];
					}
					else if (!empty($displet_rets_idx_global_model['property_city'])){
						$displet_rets_idx_global_model['city'] = str_replace('-', '%20', $displet_rets_idx_global_model['property_city']);
					}
					else if (!empty($displet_rets_idx_global_model['property_state'])){
						$displet_rets_idx_global_model['keyword'] = str_replace('-', '%20', $displet_rets_idx_global_model['property_state']);
					}
					$displet_rets_idx_global_model['query_url'] = DispletRetsIdxQuery::get_query_url($displet_rets_idx_global_model);
					if (!empty($displet_rets_idx_global_model['property_city'])){
						$displet_rets_idx_global_model['city'] = str_replace('-', ' ', $displet_rets_idx_global_model['property_city']);
					}
					else if (!empty($displet_rets_idx_global_model['property_state'])){
						$displet_rets_idx_global_model['keyword'] = str_replace('-', ' ', $displet_rets_idx_global_model['property_state']);
					}
					// Get raw data from json API server-side for crawlable content
					$listings = DispletRetsIdxQuery::get_listings($displet_rets_idx_global_model);
					$displet_rets_idx_global_model = array_merge($displet_rets_idx_global_model, $listings);
				}
			}
		}
	}

	function replace_wp_title($title) {
		global $displet_rets_idx_global_model;
		if (is_page($displet_rets_idx_global_model['page_id'])) {
			if (!empty($displet_rets_idx_global_model['property_id'])) {
				$title = $displet_rets_idx_global_model['listings'][0]->address;
			}
			else if (!empty($displet_rets_idx_global_model['property_zip'])) {
				$title = $displet_rets_idx_global_model['zip'];
			}
			else if (!empty($displet_rets_idx_global_model['property_city'])) {
				$title = $displet_rets_idx_global_model['city'];
			}
			else if (!empty($displet_rets_idx_global_model['property_state'])) {
				$title = $displet_rets_idx_global_model['keyword'];
			}
		}
		return $title;
	}

	function replace_page_title($title) {
		global $displet_rets_idx_global_model, $post, $id;
		if (is_page($displet_rets_idx_global_model['page_id']) && $id == $post->ID && in_the_loop() && self::is_referral_function('the_title')) {
			if (!empty($displet_rets_idx_global_model['property_id'])) {
				$title = DispletRetsIdxLoad::get_template('displet-property-details-page-title.php', $displet_rets_idx_global_model);
			}
			else if (!empty($displet_rets_idx_global_model['property_zip'])) {
				$title = DispletRetsIdxLoad::get_template('displet-listings-page-title.php', $displet_rets_idx_global_model);
			}
			else if (!empty($displet_rets_idx_global_model['property_city'])) {
				$title = DispletRetsIdxLoad::get_template('displet-listings-page-title.php', $displet_rets_idx_global_model);
			}
			else if (!empty($displet_rets_idx_global_model['property_state'])) {
				$title = DispletRetsIdxLoad::get_template('displet-listings-page-title.php', $displet_rets_idx_global_model);
			}
		}
		return $title;
	}

	function replace_page_content($content) {
		global $displet_rets_idx_global_model;
		if (is_page($displet_rets_idx_global_model['page_id']) && in_the_loop()) {
			if (!empty($displet_rets_idx_global_model['property_id'])) {
				$content = '<!-- Displet Property ID: ' . $displet_rets_idx_global_model['property_id'] . ' -->';
				$content .= DispletRetsIdxLoad::get_template('displet-facebook-login-jquery.php', $displet_rets_idx_global_model);
				$content .= DispletRetsIdxLoad::get_template('displet-property-details-page-jquery.php', $displet_rets_idx_global_model);
				$content .= DispletRetsIdxLoad::get_template('displet-property-details-page-content.php', $displet_rets_idx_global_model);
				$content .= DispletRetsIdxLoad::get_template('displet-property-details-page-popups.php', $displet_rets_idx_global_model);
			}
			else {
				if (!empty($displet_rets_idx_global_model['property_zip'])){
					$content = '<!-- Displet Property Zip: ' . $displet_rets_idx_global_model['zip'] . ' -->';
					$content .= DispletRetsIdxLoad::get_template('displet-property-unavailable-jquery.php', $displet_rets_idx_global_model);
				}
				else if (!empty($displet_rets_idx_global_model['property_city'])){
					$content = '<!-- Displet Property City: ' . $displet_rets_idx_global_model['city'] . ' -->';
				}
				else if (!empty($displet_rets_idx_global_model['property_state'])){
					$content = '<!-- Displet Property State: ' . $displet_rets_idx_global_model['keyword'] . ' -->';
				}
				if (!empty($displet_rets_idx_global_model['property_state']) || !empty($displet_rets_idx_global_model['property_city']) || !empty($displet_rets_idx_global_model['property_zip'])) {
					if (intval($displet_rets_idx_global_model['meta']->count) > 0) {
						$content .= DispletRetsIdxLoad::get_template('displet-listings-jquery.php', $displet_rets_idx_global_model);
						$content .= DispletRetsIdxLoad::get_template('displet-map-jquery.php', $displet_rets_idx_global_model);
						if ($displet_rets_idx_global_model['is_displet_api']) {
							if (intval($displet_rets_idx_global_model['meta']->count) > 9) {
								$content .= DispletRetsIdxLoad::get_template('displet-price-navigation.php', $displet_rets_idx_global_model);
							}
							$content .= DispletRetsIdxLoad::get_template('displet-statistics.php', $displet_rets_idx_global_model);
						}
					}
					$content .= DispletRetsIdxLoad::get_template('displet-dynamic.php', $displet_rets_idx_global_model);
				}
			}
		}
		return $content;
	}

	function generate_rewrite_rules(){
		$displet_rets_idx_option = DispletRetsIdxSettings::get_option();
		$id = $displet_rets_idx_option['displet_rets_idx_option_property_details_page_id'];
		$pagename = get_page($id)->post_name;
		$rule = $pagename . '/([^/]+)/?([^/]*)/?([^/]*)/?(\d*)/?([^/]*)/?$';
		$rewrite = 'index.php?pagename=' . $pagename . '&property_state=$matches[1]&property_city=$matches[2]&property_zip=$matches[3]&property_id=$matches[4]&property_address=$matches[5]';
		$property_state_tag = '%property_state%';
		$property_city_tag = '%property_city%';
		$property_zip_tag = '%property_zip%';
		$property_address_tag = '%property_address%';
		$property_id_tag = '%property_id%';
		$args = array(
			'paged' => false
		);
		add_rewrite_tag($property_state_tag, $rule);
		add_rewrite_tag($property_city_tag, $rule);
		add_rewrite_tag($property_zip_tag, $rule);
		add_rewrite_tag($property_address_tag, $rule);
		add_rewrite_tag($property_id_tag, $rule);
		add_rewrite_rule($rule, $rewrite, 'top');
	}

	function flush_rewrite_rules(){
		$rules = get_option('rewrite_rules');
		$displet_rets_idx_option = DispletRetsIdxSettings::get_option();
		$id = $displet_rets_idx_option['displet_rets_idx_option_property_details_page_id'];
		$pagename = get_page($id)->post_name;
		if (!isset($rules[$pagename . '/([^/]+)/?([^/]*)/?([^/]*)/?(\d*)/?([^/]*)/?$'])){
			global $wp_rewrite;
		   	$wp_rewrite->flush_rules();
		}
	}

	function replace_canonical(){
		global $displet_rets_idx_global_model;
		if (!empty($displet_rets_idx_global_model['property_id']) || !empty($displet_rets_idx_global_model['property_state']) || !empty($displet_rets_idx_global_model['property_city']) || !empty($displet_rets_idx_global_model['property_zip'])) {
			remove_action('wp_head', 'rel_canonical');
			add_action('wp_head', array('DispletRetsIdxUrlStructure', 'new_canonical'), 1);
		}
	}

	function new_canonical(){
		global $displet_rets_idx_global_model;
		if (!empty($displet_rets_idx_global_model['property_id'])) {
	    	$link = rtrim(get_permalink($displet_rets_idx_global_model['page_id']), '/') . '/' .
	    		stripslashes(str_replace(' ', '-', $displet_rets_idx_global_model['listings'][0]->state)) . '/' .
	    		stripslashes(str_replace(' ', '-', $displet_rets_idx_global_model['listings'][0]->city)) . '/' .
	    		stripslashes(str_replace(' ', '-', $displet_rets_idx_global_model['listings'][0]->zip)) . '/' .
	    		$displet_rets_idx_global_model['property_id'] . '/' .
	    		stripslashes(str_replace(' ', '-', str_replace('#', '', $displet_rets_idx_global_model['listings'][0]->address)));
		}
		else if (!empty($displet_rets_idx_global_model['property_zip'])) {
	    	$link = rtrim(get_permalink($displet_rets_idx_global_model['page_id']), '/') . '/' .
	    		stripslashes(str_replace(' ', '-', $displet_rets_idx_global_model['property_state'])) . '/' .
	    		stripslashes(str_replace(' ', '-', $displet_rets_idx_global_model['property_city'])) . '/' .
	    		stripslashes(str_replace(' ', '-', $displet_rets_idx_global_model['property_zip']));
		}
		else if (!empty($displet_rets_idx_global_model['property_city'])) {
	    	$link = rtrim(get_permalink($displet_rets_idx_global_model['page_id']), '/') . '/' .
	    		stripslashes(str_replace(' ', '-', $displet_rets_idx_global_model['property_state'])) . '/' .
	    		stripslashes(str_replace(' ', '-', $displet_rets_idx_global_model['property_city']));
		}
		else if (!empty($displet_rets_idx_global_model['property_state'])) {
	    	$link = rtrim(get_permalink($displet_rets_idx_global_model['page_id']), '/') . '/' .
	    		stripslashes(str_replace(' ', '-', $displet_rets_idx_global_model['property_state']));
		}
	    echo '<link rel="canonical" href="' . esc_url($link) . '" />' . "\n";
	}

	function remove_yoasts_canonical($canonical) {
		global $displet_rets_idx_global_model, $post;
		if (!empty($displet_rets_idx_global_model['property_id']) || !empty($displet_rets_idx_global_model['property_zip']) || !empty($displet_rets_idx_global_model['property_city']) || !empty($displet_rets_idx_global_model['property_state'])) {
	    	$canonical = false;
	    }
		return $canonical;
	}

	// Whitelist query var for Yoast's redirect option
	/* Should work but doesn't :-( - $_GET['property_id'] fails in Yoast's code, whereas get_query_var('property_id') doesn't
	function whitelist_query_var_from_yoasts_redirect($whitelisted_extravars) {
		$whitelisted_extravars = array('property_id');
		return $whitelisted_extravars;
	}
	*/

	function redirect_to_canonical(){
		global $displet_rets_idx_global_model;
		if (!empty($displet_rets_idx_global_model['property_id']) && !empty($displet_rets_idx_global_model['property_zip']) && !empty($displet_rets_idx_global_model['property_city']) && !empty($displet_rets_idx_global_model['property_state'])) {
			$address = get_query_var('property_address');
			$listing_zip = stripslashes(str_replace(' ', '-', $displet_rets_idx_global_model['listings'][0]->zip));
			$listing_city = stripslashes(str_replace(' ', '-', $displet_rets_idx_global_model['listings'][0]->city));
			$listing_state = stripslashes(str_replace(' ', '-', $displet_rets_idx_global_model['listings'][0]->state));
			$listing_address = stripslashes(str_replace(' ', '-', str_replace('#', '', $displet_rets_idx_global_model['listings'][0]->address)));
			$property_address = (!empty($address)) ? $address : $listing_address;
			if ($displet_rets_idx_global_model['property_zip'] != $listing_zip || $displet_rets_idx_global_model['property_city'] != $listing_city || $displet_rets_idx_global_model['property_state'] != $listing_state || $property_address != $listing_address) {
				//echo $displet_rets_idx_global_model['property_zip'] . '!=' . $listing_zip . '||' . $displet_rets_idx_global_model['property_city'] . '!=' . $listing_city . '||' . $displet_rets_idx_global_model['property_state'] . '!=' . $listing_state . '||' . $property_address . '!=' . $listing_address;
	    		$link = rtrim(get_permalink($displet_rets_idx_global_model['page_id']), '/') . '/' .
	    			$listing_state . '/' .
	    			$listing_city . '/' .
	    			$listing_zip . '/' .
	    			$displet_rets_idx_global_model['property_id'] . '/' .
	    			$listing_address;
	    		wp_safe_redirect($link, 301);
			}
		}
	}

	function redirect_to_parent(){
		global $displet_rets_idx_global_model;
		if (is_page($displet_rets_idx_global_model['page_id']) && !empty($displet_rets_idx_global_model['property_id'])) {
			if (empty($displet_rets_idx_global_model['listings'][0])) {
				$property_address = get_query_var('property_address');
	    		$link = rtrim(get_permalink($displet_rets_idx_global_model['page_id']), '/') . '/' .
	    			stripslashes(str_replace(' ', '-', $displet_rets_idx_global_model['property_state'])) . '/' .
	    			stripslashes(str_replace(' ', '-', $displet_rets_idx_global_model['property_city'])) . '/' .
	    			stripslashes(str_replace(' ', '-', $displet_rets_idx_global_model['property_zip'])) . '#listing=' . $displet_rets_idx_global_model['property_id'] . '/';
	    		if (!empty($property_address)) {
	    			$link .= 'address=' . $property_address . '/';
	    		}
	    		$link .= 'status=unavailable';
	    		wp_safe_redirect($link, 301);
			}
			else{
				self::redirect_to_canonical();
			}
		}
	}

	// Determine referral function (useful to prevent unintentional title adjustments in menus)
	function is_referral_function($f) {
		$aray = debug_backtrace(DEBUG_BACKTRACE_IGNORE_ARGS);
		foreach($aray as $a) {	$aa[] = $a["function"];	}
		if(in_array($f,$aa)) { return true; }
		return false;
	}

}

add_action('wp', array('DispletRetsIdxUrlStructure', 'create_global_model'));
add_filter('wp_title', array('DispletRetsIdxUrlStructure', 'replace_wp_title'), 1000000);
add_filter('the_title', array('DispletRetsIdxUrlStructure', 'replace_page_title'));
add_filter('the_content', array('DispletRetsIdxUrlStructure', 'replace_page_content'));
add_action('init', array('DispletRetsIdxUrlStructure', 'generate_rewrite_rules'));
add_action('wp_loaded', array('DispletRetsIdxUrlStructure', 'flush_rewrite_rules'));
add_action('template_redirect', array('DispletRetsIdxUrlStructure', 'replace_canonical'));
add_action('template_redirect', array('DispletRetsIdxUrlStructure', 'redirect_to_parent'), 1);
add_filter('wpseo_canonical', array('DispletRetsIdxUrlStructure', 'remove_yoasts_canonical'));
//add_filter('wpseo_whitelist_permalink_vars', array('DispletRetsIdxUrlStructure', 'whitelist_query_var_from_yoasts_redirect'));

?>