<script>
jQuery(document).ready(function($){
	$('#displet_delete_selected_users').click(function(){
		var users_array = new Array();
		$('.displetreader.leads table input:checked').each(function(){
			users_array.push($(this).attr('id'))
		});
		if (users_array.length) {
			var confirm = window.confirm('Are you sure you wish to delete the selected users?');
			if (confirm == true){
				var data = {
				    action: 'displet_delete_users_request',
				    _ajax_nonce: '<?php echo wp_create_nonce("displet_delete_users_nonce"); ?>',
				    displet_users: users_array,
				};
				$.post("<?php echo admin_url('admin-ajax.php'); ?>", data, function(response) {
					if (response == 'Succesful Deletion') {
						for (var i = users_array.length - 1; i >= 0; i--) {
							$('.displetreader.leads table tr.displet-lead-' + users_array[i]).fadeOut();
						};
					}
					else {
						alert(response);
						window.location.reload();
					}
				});
			}
		}
		else{
			alert('No user has been selected.');
		}
	});
});
</script>
<?php
	// Get settings
	$displet_rets_idx_option = DispletRetsIdxSettings::get_option();

	// Get users tagged as leads
	$args = array(
		'meta_key' => 'displet_lead',
		'meta_value' => true,
		'orderby' => 'registered',
		'order' => 'DESC'
	);
	$leads = get_users($args);
?>
<div class="wrap displetreader leads">
	<h2>Displet Leads</h2>
	<table>
		<tr>
			<th></th>
			<th>User Name</th>
			<th>User Email</th>
			<th>User Phone</th>
			<th>Last Search</th>
			<th>Last Login</th>
			<th>Registration Timestamp</th>
			<th>Registration Page</th>
			<th>Referring Page</th>
		</tr>
		<?php
			if (!empty($leads)) {
				foreach ($leads as $lead) {
					$lead->edit_url = admin_url('user-edit.php?user_id=' . $lead->ID);
					$last_search_link = !empty($lead->displet_last_hash) ? '<a href="' . get_permalink($displet_rets_idx_option['displet_rets_idx_option_search_results_page_id']) . $lead->displet_last_hash . '" target="_blank">' . get_permalink($displet_rets_idx_option['displet_rets_idx_option_search_results_page_id']) . $lead->displet_last_hash . '</a>' : '';
					echo
						'<tr class="displet-lead-' . $lead->ID . '">
							<td><input id="' . $lead->ID . '" type="checkbox"></td>
							<td><a href="' . $lead->edit_url . '">' . $lead->nickname . '</a></td>
							<td><a href="mailto:' . $lead->user_email . '">' . $lead->user_email . '</a></td>
							<td>' . $lead->displet_phone . '</td>
							<td class="url lastsearch">' . $last_search_link . '</td>
							<td>' . $lead->displet_last_login . '</td>
							<td>' . $lead->user_registered . '</td>
							<td class="url"><a href="' . $lead->displet_registration_url . '" target="_blank">' . $lead->displet_registration_url . '</a></td>
							<td class="url"><a href="' . $lead->displet_registration_upstream_url . '" target="_blank">' . $lead->displet_registration_upstream_url . '</a></td>
						</tr>';	
				}
			}
			else{
				echo '<tr><td colspan="9">There are no leads at this time.</td></tr>';
			}
		?>
	</table>
	<div class="submit">
		<a href="javascript:void(0);" id="displet_delete_selected_users" class="button-primary">Delete Selected Users</a>
	</div>
	<div class="displet-response"><!-- --></div>
</div>