<?php
	// Get settings
	$displet_rets_idx_option = DispletRetsIdxSettings::get_option();
?>
<!--[if lt IE 9]>
	<style>
		.tileoverlay div {
			/* IE8+ - must be on one line, unfortunately */
			-ms-filter: "progid:DXImageTransform.Microsoft.Matrix(M11=0.7071067811865474, M12=-0.7071067811865477, M21=0.7071067811865477, M22=0.7071067811865474, SizingMethod='auto expand')";
			/* IE6 and 7 */
			filter: progid:DXImageTransform.Microsoft.Matrix(
				M11=0.7071067811865474,
				M12=-0.7071067811865477,
				M21=0.7071067811865477,
				M22=0.7071067811865474,
				SizingMethod='auto expand');
			margin-left: 20px !important;
			margin-top: 3px !important;
			width: 100px;
		}
	</style>
<![endif]-->
<div id="displet-dynamic">
	<div class="displet-unavailable"><!-- --></div>
	<div class="displet-orientation">
		<a class="displet-tile-view<?php if ($model['orientation'] == 'gallery') echo ' current' ?>">Gallery</a>
		<a class="displet-list-view<?php if ($model['orientation'] == 'list') echo ' current' ?>">List</a>
		<a class="displet-map-view<?php if ($model['orientation'] == 'map') echo ' current' ?>">Map</a>
		<div class="displet-clear"><!-- --></div>
	</div>
	<div class="displet-controls">
		<div class="displet-counts">
			<span class="displet-first-listings-value"><?php echo $model['meta']->first ?></span>
			&ndash;
			<span class="displet-last-listings-value"><?php echo $model['meta']->last ?></span>
			of
			<span class="displet-total-listings-value"><?php echo number_format(intval($model['meta']->count)); ?></span>
		</div>
		<a href="<?php echo $model['previous_page_url']; ?>" class="displet-previous-listings-link" displet_query="<?php echo $model['query_url']; ?>">
			<span class="displet-previous-icon">&laquo;</span>
			<span class="displet-previous">Prev</span>
		</a>
		<a href="<?php echo $model['next_page_url']; ?>" class="displet-next-listings-link" displet_query="<?php echo $model['query_url']; ?>">
			<span class="displet-next">Next</span>
			<span class="displet-next-icon">&raquo;</span>
		</a>
		<select class="displet-listings-sortby" name="sort_by">
			<option value="">Sort By</option>
			<option value="price-ascending">Price Low to High</option>
			<option value="price-descending">Price High to Low</option>
			<?php if (!$model['is_displet_api']) : ?>
				<option value="date-descending">Newest</option>
				<option value="date-ascending">Oldest</option>
			<?php endif; ?>
		</select>
	</div>
	<div id="displet-listings" class="displet_json_response" is_displet_api="<?php echo ($model['is_displet_api']) ? 'true' : 'false'; ?>">
		<?php
			$i = 1;
			foreach ($model['listings'] as $listing) :
				// Create first image, address & bathrooms
				if ($model['is_displet_api']) {
					echo '<!-- ' . $listing->image_urls . ' -->';
					//$listing->images[0]->src = preg_match('/daf/', $listing->image_urls);
					$listing->address = trim($listing->street_number . ' ' . $listing->street_name . ' ' . $listing->street_post_dir);
					$half_baths = (!empty($listing->half_baths)) ? '/' . $listing->half_baths : '';
					$listing->bathrooms = $listing->full_baths . $half_baths;
				}
				// Translate variables for free version
				else{
					$listing->sysid = $listing->id;
					$listing->list_price = $listing->attributes->price;
					$listing->address = $listing->location->address;
					$listing->city = $listing->location->name;
					$listing->state = $listing->location->state;
					$listing->zip = $listing->location->zip;
					$listing->num_bedrooms = $listing->attributes->bedrooms;
					$listing->bathrooms = $listing->attributes->bathrooms;
					$listing->square_feet = $listing->attributes->square_feet;
					$listing->property_type = $listing->category->name;
					$listing->mls_number = $listing->attributes->mls_id;
					$listing->internet_remarks = $listing->body;
				}
				// Create permalink
				$listing->base_url = get_permalink($displet_rets_idx_option['displet_rets_idx_option_property_details_page_id']);
				$permalink_state = (!empty($listing->state)) ? $listing->state : 'STATE';
				$permalink_city = (!empty($listing->city)) ? $listing->city : 'City';
				$permalink_zip = (!empty($listing->zip)) ? $listing->zip : '00000';
				$listing->permalink = rtrim($listing->base_url, '/') . '/' .
					stripslashes(str_replace(' ', '-', $permalink_state)) . '/' .
					stripslashes(str_replace(' ', '-', $permalink_city)) . '/' .
					stripslashes(str_replace(' ', '-', $permalink_zip)) . '/' .
					$listing->sysid . '/' .
					stripslashes(str_replace(' ', '-', str_replace('#', '', $listing->address)));
				// Swap phones, emails and URLs from description
				if (!empty($listing->internet_remarks)) {
					$phone = '/([0-9]{3})[-. ]?([0-9]{4})/';
					$email = '/([\S]+)@([\S]+)/';
					$website = '/([\S]+)\.com([\S]+)/';
					$new_body = preg_replace($phone, 'XXX-XXXX', $listing->internet_remarks);
					$new_body = preg_replace($email, 'XXXX@XXXX', $new_body);
					$new_body = preg_replace($website, 'http://.com', $new_body);
					$listing->internet_remarks = $new_body;
					// Limit length of remarks
    				$truncated_body_array = preg_split('/\s+/', $new_body, 49);
    				array_pop($truncated_body_array);
    				$complete_body_array = preg_split('/\s+/', $new_body);
    				array_pop($complete_body_array);
    				if (count($complete_body_array) > count($truncated_body_array)) {
    					$listing->internet_remarks = implode(' ', $truncated_body_array) . ' ...';
    				}
    				else{
    					$listing->internet_remarks = $new_body;
    				}
				}
		?>
			<a class="displet-tile-listing displet-listing-<?php echo $i; ?> displet-listing" href="<?php echo $listing->permalink ?>" name="<?php echo $listing->base_url; ?>"<?php if ($model['orientation'] != 'gallery') echo ' style="display: none;"' ?>>
				<div class="displet-tile-hovertrans displet-limit-api-find">
					<div class="displet-inner">
						<div class="displet-inner2"><!-- --></div>
					</div>
				</div>
				<div class="displet-tile-thumb-container">
					<img class="displet-image displet-image-value"<?php if ($listing->images[0]->src) echo ' style="background-image: url(' . $listing->images[0]->src . ');"'; ?> />
					<div class="tileoverlay contract displet-limit-api-find" style="display:none;"><div>Under Contract</div></div>
					<div class="tileoverlay contingency displet-limit-api-find" style="display:none;"><div>Contingency</div></div>
				</div>
				<div class="displet-tile-price-container">
					<span class="displet-dollar">$</span>
					<span class="displet-price-value">
						<?php echo number_format($listing->list_price); ?>
					</span>
					<div class="displet-clear"><!-- --></div>
				</div>
				<div class="displet-tile-info">
					<div class="displet-tile-address">
						<div class="displet-address displet-address-value"<?php if (empty($listing->address)) echo ' style="display: none;"'; ?>>
							<?php echo $listing->address; ?>
						</div>
						<div class="displet-city-state-zip"<?php if (empty($listing->city) && empty($listing->state) && empty($listing->zip)) echo ' style="display: none;"'; ?>>
							<span class="displet-city displet-city-value"><?php echo $listing->city; ?></span>,
							<span class="displet-state displet-state-value"><?php echo $listing->state; ?></span>
							<span class="displet-zip displet-zip-value"><?php echo $listing->zip; ?></span>
						</div>
					</div>
					<div class="displet-tile-specs">
						<div class="displet-beds-baths">
							<span class="displet-beds"<?php if (empty($listing->num_bedrooms)) echo ' style="display: none;"'; ?>>
								<span class="displet-beds-value">
									<?php echo $listing->num_bedrooms; ?>
								</span>
								Bed /
							</span>
							<span class="displet-baths"<?php if (empty($listing->bathrooms)) echo ' style="display: none;"'; ?>>
								<span class="displet-full-baths displet-baths-value">
									<?php echo $listing->bathrooms; ?>
								</span>
								Bath
							</span>
						</div>
						<div class="displet-square-feet"<?php if (empty($listing->square_feet)) echo ' style="display: none;"'; ?>>
							<span class="displet-square-feet-value"><?php echo number_format($listing->square_feet); ?></span>
							Sq. Ft.
						</div>
						<div class="displet-property-type"<?php if (empty($listing->property_type)) echo ' style="display: none;"'; ?>>
							Property Type:
							<span class="displet-property-type-value"><?php $property_type = str_replace('Houses', 'House', $listing->property_type); echo str_replace('Condos, Townhouses & Apts for Sale', 'Condo / Townhouse / Apt', $property_type); ?></span>
						</div>
					</div>
				</div>
			</a>
			<a class="displet-vertical-listing displet-listing-<?php echo $i; ?> displet-listing" href="<?php echo $listing->permalink ?>" name="<?php echo $listing->base_url; ?>"<?php if ($model['orientation'] != 'list') echo ' style="display: none;"' ?>>
				<div class="displet-listing-hovertrans displet-limit-api-find">
					<div class="displet-inner">
						<div class="displet-inner2"><!-- --></div>
					</div>
				</div>
				<div class="displet-listing-thumb-container">
					<img class="displet-image displet-image-value"<?php if ($listing->images[0]->src) echo ' style="background-image: url(' . $listing->images[0]->src . ');"'; ?> />
					<div class="tileoverlay contract displet-limit-api-find" style="display:none;"><div>Under Contract</div></div>
					<div class="tileoverlay contingency displet-limit-api-find" style="display:none;"><div>Contingency</div></div>
				</div>
				<div class="displet-listing-info">
					<div class="displet-listing-price">
						<span class="displet-listing-dollar">$</span>
						<span class="displet-price-value"><?php echo number_format($listing->list_price); ?></span>
					</div>
					<div class="displet-listing-address">
						<span class="displet-address"<?php if (empty($listing->address)) echo ' style="display: none;"'; ?>>
							<span class="displet-address-value">
								<?php echo $listing->address; ?>
							</span>
							|
						</span>
						<span class="displet-city-state-zip"<?php if (empty($listing->city) && empty($listing->state) && empty($listing->zip)) echo ' style="display: none;"'; ?>>
							<span class="displet-city displet-city-value"><?php echo $listing->city; ?></span>,
							<span class="displet-state displet-state-value"><?php echo $listing->state; ?></span>
							<span class="displet-zip displet-zip-value"><?php echo $listing->zip; ?></span>
						</span>
					</div>
					<div class="displet-clear"><!-- --></div>
					<table class="displet-listing-specs">
						<thead>
							<tr>
								<th class="displet-mls"<?php if (empty($listing->mls_number)) echo ' style="display: none;"'; ?>>
									MLS#
								</th>
								<th class="displet-property-type"<?php if (empty($listing->property_type)) echo ' style="display: none;"'; ?>>
									Property Type
								</th>
								<th class="displet-beds"<?php if (empty($listing->num_bedrooms)) echo ' style="display: none;"'; ?>>
									Beds
								</th>
								<th class="displet-baths"<?php if (empty($listing->bathrooms)) echo ' style="display: none;"'; ?>>
									Baths
								</th>
								<th class="displet-square-feet"<?php if (empty($listing->square_feet)) echo ' style="display: none;"'; ?>>
									Square Ft
								</th>
							</tr>
						</thead>
						<tbody>
							<tr>
								<td class="displet-mls displet-mls-value"<?php if (empty($listing->mls_number)) echo ' style="display: none;"'; ?>>
									<?php echo $listing->mls_number; ?>
								</td>
								<td class="displet-property-type displet-property-type-value"<?php if (empty($listing->property_type)) echo ' style="display: none;"'; ?>>
									<?php
										$property_type = str_replace('Houses', 'House', $listing->property_type);
										echo str_replace('Condos, Townhouses & Apts for Sale', 'Condo / Townhouse / Apt', $property_type);
									?>
								</td>
								<td class="displet-beds displet-beds-value"<?php if (empty($listing->num_bedrooms)) echo ' style="display: none;"'; ?>>
									<?php echo $listing->num_bedrooms; ?>
								</td>
								<td class="displet-baths displet-baths-value"<?php if (empty($listing->bathrooms)) echo ' style="display: none;"'; ?>>
									<?php echo $listing->bathrooms; ?>
								</td>
								<td class="displet-square-feet"<?php if (empty($listing->square_feet)) echo ' style="display: none;"'; ?>>
									<span class="displet-square-feet-value"><?php echo number_format($listing->square_feet); ?></span>
									s.f.
								</td>
							</tr>
						</tbody>
					</table>
					<div class="displet-description displet-description-value"<?php if (empty($listing->internet_remarks)) echo ' style="display: none;"'; ?>>
						<?php echo $listing->internet_remarks; ?>
					</div>
					<div class="displet-text-overlay"><!-- --></div>
					<div class="displet-text-overlay-hovertrans"><!-- --></div>
				</div>
				<div class="displet-clear"><!-- --></div>
			</a>
		<?php
			$i++; endforeach;
		?>
		<div class="displet-clear"><!-- --></div>
	</div>
	<div class="displet-no-results" style="display: none;">No listings available.</div>
	<div id="displet-map"<?php if ($model['orientation'] != 'map') echo ' class="hiding"'; ?>>
		<script type="text/javascript" src="http://maps.google.com/maps/api/js?sensor=false"></script>
		<div id="map_canvas_outer">
			<div id="map_canvas" style="width: 100%; height: 300px;"><!-- --></div>
			<div class="displet-listings-loading"><!-- --></div>
		</div>
	</div>
	<div class="displet-controls">
		<div class="displet-counts">
			<span class="displet-first-listings-value"><?php echo $model['meta']->first ?></span>
			&ndash;
			<span class="displet-last-listings-value"><?php echo $model['meta']->last ?></span>
			of
			<span class="displet-total-listings-value"><?php echo number_format(intval($model['meta']->count)); ?></span>
		</div>
		<a href="#prev" class="displet-previous-listings-link" displet_query="<?php echo $model['query_url']; ?>">
			<span class="displet-control-prev-icon">&laquo;</span>
			<span class="displet-control-prev">Prev</span>
		</a>
		<a href="#next" class="displet-next-listings-link" displet_query="<?php echo $model['query_url']; ?>">
			<span class="displet-next">Next</span>
			<span class="displet-next-icon">&raquo;</span>
		</a>
	</div>
	<div class="displet-powered">
		Powered by
		<?php if ($displet_rets_idx_option['displet_rets_idx_option_no_link']) : ?>
			Displet Real Estate Search
		<?php else : ?>
			<a href="http://displet.com/wordpress-plugins/displet-rets-idx-plugin/" target="_blank">Displet Real Estate Search</a>
		<?php endif; ?>
	</div>
	<?php if ($displet_rets_idx_option['displet_rets_idx_option_disclaimer']) : ?>
		<div class="displet-tile-disclaimer">
			<?php echo $displet_rets_idx_option['displet_rets_idx_option_disclaimer']; ?>
		</div>
	<?php endif; ?>
	<div class="displet-listings-loading" style="display: none;"><!-- --></div>
</div>