<?php
	// Get settings
	$displet_rets_idx_option = DispletRetsIdxSettings::get_option();
?>
<script>
	jQuery(document).ready(function($) {
		// Get default query and update sort
		var default_query = '<?php echo $model["query_url"]; ?>';
		var last_sort = $.cookie('displet_last_viewed_listings_sort', {path: '/'});
		if (last_sort != undefined) {
			if (<?php echo ($model['is_displet_api']) ? 'true' : 'false'; ?>) {
				var sort_check = /[?&]priceSorter=([^&]+)/i;
			}
			else{
				var sort_check = /[?&]sort=([^&]+)/i;
			}
			var current_sort = default_query.match(sort_check);
		}
		if (last_sort != undefined && current_sort != undefined && last_sort != current_sort[0]){
			sorted_query = default_query.replace(sort_check, last_sort);
			loadDispletAPIListings(sorted_query, <?php echo ($model['is_displet_api']) ? 'true' : 'false'; ?>);
			console.log(sorted_query, 'Displet Q Cookie');
		}
		else {
			// Only render map, default listings loaded (already rendered server-side)
			$('#displet-map .displet-listings-loading').show();
			var displet_map_listings_array = new Array();
			var current_lat_total = 0;
			var current_long_total = 0;
			<?php
				foreach ($model['listings'] as $listing) :
				// Create address
				if ($model['is_displet_api']) {
					$listing->address = trim($listing->street_number . ' ' . $listing->street_name . ' ' . $listing->street_post_dir);
					if (!empty($listing->half_baths)) {
						$half_baths = '/' + $listing->half_baths;
					}
					else{
						$half_baths = '';
					}
					$listing->bathrooms = $listing->full_baths + $half_baths;
				}
				// Translate variables for free version
				else{
					$listing->latitude = $listing->location->latitude;
					$listing->longitude = $listing->location->longitude;
					$listing->sysid = $listing->id;
					$listing->list_price = $listing->attributes->price;
					$listing->address = $listing->location->address;
					$listing->city = $listing->location->name;
					$listing->state = $listing->location->state;
					$listing->zip = $listing->location->zip;
					$listing->num_bedrooms = $listing->attributes->bedrooms;
					$listing->bathrooms = $listing->attributes->bathrooms;
					$listing->square_feet = $listing->attributes->square_feet;
				}
				if (!empty($listing->sysid)) {
					$permalink_state = (!empty($listing->state)) ? $listing->state : 'STATE';
					$permalink_city = (!empty($listing->city)) ? $listing->city : 'City';
					$permalink_zip = (!empty($listing->zip)) ? $listing->zip : '00000';
					$listing->permalink = rtrim(get_permalink($displet_rets_idx_option['displet_rets_idx_option_property_details_page_id']), '/') . '/' . str_replace(' ', '-', $permalink_state) . '/' . str_replace(' ', '-', $permalink_city) . '/' . str_replace(' ', '-', $permalink_zip) . '/' . $listing->sysid;
					if ($listing->address) {
						$listing->permalink .= '/' . str_replace(' ', '-', $listing->address);
					}
				}
				if (!empty($listing->latitude) && !empty($listing->longitude)) : 
			?>
				var this_listing = [<?php echo $listing->latitude; ?>, <?php echo $listing->longitude; ?>, '<?php echo $listing->address; ?>', '<?php echo $listing->permalink; ?>', '<?php echo $listing->list_price; ?>', '<?php echo $listing->images[0]->src; ?>', '<?php echo $listing->square_feet; ?>', '<?php echo $listing->num_bedrooms; ?>', '<?php echo $listing->bathrooms; ?>'];
				displet_map_listings_array.push(this_listing);
				current_lat_total += parseFloat(<?php echo $listing->latitude; ?>);
				current_long_total += parseFloat(<?php echo $listing->longitude; ?>);
			<?php endif; endforeach; ?>
			renderDispletMap(displet_map_listings_array, current_lat_total, current_long_total);
			$('#displet-map .displet-listings-loading').hide();
			console.log(default_query, 'Displet Q');
		}
	});
</script>