<script>
function renderDispletMap(displet_map_listings_array, current_lat_total, current_long_total) {
	if (displet_map_listings_array.length !== -1) {
		var first = true;
		var bounds = new google.maps.LatLngBounds();
		var lat_average = current_lat_total / displet_map_listings_array.length;
		var long_average = current_long_total / displet_map_listings_array.length;
		var variance = <?php echo $model['map_variance']; ?>;

		// Plot marker and bounds for each listing
		for (var i = 0; i < displet_map_listings_array.length; i++){
			if (displet_map_listings_array[i][0] != null && displet_map_listings_array[i][1] != null && displet_map_listings_array[i][0] > (lat_average - variance) && displet_map_listings_array[i][0] < (lat_average + variance) && displet_map_listings_array[i][1] > (long_average - variance) && displet_map_listings_array[i][1] < (long_average + variance)) {
				var listing_lat_long = new google.maps.LatLng(displet_map_listings_array[i][0], displet_map_listings_array[i][1]);

				// Create map if first lat/long
				if (first) {
					var map = new google.maps.Map(document.getElementById('map_canvas'), {
    					zoom: 12,
    					center: listing_lat_long,
    					mapTypeId: google.maps.MapTypeId.ROADMAP
					});
					var first = false;
				}
				
				var marker = new google.maps.Marker({
					map: map,
					position: listing_lat_long,
					address: displet_map_listings_array[i][2],
					url: displet_map_listings_array[i][3],
					price: displet_map_listings_array[i][4],
					photo: displet_map_listings_array[i][5],
					sqft: displet_map_listings_array[i][6],
					beds: displet_map_listings_array[i][7],
					baths: displet_map_listings_array[i][8]
				});
				google.maps.event.addListener(marker, 'click', function() {
					onMarkerClick(this, this.address, this.url, this.price, this.photo, this.sqft, this.beds, this.baths);
				});
				bounds.extend(listing_lat_long);
			}
		}

		if (marker != undefined){
			// Interpret markers
	    	var infoWindow = new google.maps.InfoWindow;
	    	function onMarkerClick(marker, address, url, price, photo, sqft, beds, baths) {
	    		var latLng = marker.getPosition();
	    		var map_content = '<div class="marker-inner">';
	    		if (url != undefined && url != ''){
	    			map_content += '<a href="' + url + '">';
	    		}
	    		if (photo != undefined && photo != '') {
	    			map_content += '<img class="displet-image" src="' + photo + '" />'
	    		}
	    			map_content += '<div class="displet-content">';
	    		if (address != undefined && address != '') {
	    			map_content += '<div class="displet-address">' + address + '</div>';
	    		}
	    		if (price != undefined && price != '') {
	    			map_content += '<div><span>List price:</span> $' + displetretsidxCommasToNumber(price) + '</div>';
	    		}
	    		if (sqft != undefined && sqft != '') {
	    			map_content += '<div><span>Size: </span>' + sqft + ' Sq. Ft.</div>';
	    		}
	    		map_content += '<div>';
	    		if (beds != undefined && beds != '') {
	    			map_content += '<span>Beds: </span>' + beds;
	    		}
	    		if (baths != undefined && baths != '') {
	    			map_content += ' | <span>Baths: </span>' + baths;
	    		}
	    		map_content += '</div></div><div class="displet-clear"><!-- --></div>';
	    		if (url != undefined && url != ''){
	    			map_content += '</a>';
	    		}
	    		map_content += '</a></div>';
	    		infoWindow.setContent(map_content);
	    		infoWindow.open(map, marker);
	    	};
	
	    	google.maps.event.addListener(map, 'click', function() {
	    		infoWindow.close();
	    	});
	
	    	// Fit to bounds
			map.fitBounds(bounds);
		}
	}
}
</script>