<?php
	$number_of_navs = (intval($model['meta']->count) > 24) ? 8 : 5;
	$price_min = intval($model['meta']->list_price_min);
	$price_max = intval($model['meta']->list_price_max);
	$price_segment = intval(($price_max - $price_min) / $number_of_navs);
	for ($i = ($price_min + $price_segment); $i <= $price_max; $i += $price_segment) {
		if ($i > 1000000) {
			$price_round = 250000;
		}
		else if ($i > 500000) {
			$price_round = 100000;
		}
		else {
			$price_round = 50000;
		}
		if ($i == ($price_min + $price_segment)) {
			$all_price_points[] = ceil($i / $price_round) * $price_round;
		}
		else if ($price_max < ($i + $price_segment)) {
			$all_price_points[] = floor($i / $price_round) * $price_round;
		}
		else{
			$all_price_points[] = round($i / $price_round) * $price_round;
		}
	}
	$price_points = array_unique($all_price_points);
?>
<div id="displet-price-navigation">
	<?php if (!empty($model['caption'])) : ?>
		<div class="displet-title">
			<?php echo $model['caption']; ?> by Price
		</div>
	<?php endif; ?>
	<table>
		<tbody>
			<tr>
				<td>
					<a class="displet-price-navigation active" displetminprice="0" displetmaxprice="999999999">All Prices</a>
				</td>
				<?php
					$previous_price_point = false;
					$first = true;
					$i = 2;
					foreach ($price_points as $price_point) {
						if ($i % 3 == 1) {
							echo '</tr><tr>';
						}
						if ($first){
							echo '<td><a class="displet-price-navigation" displetminprice="0" displetmaxprice="' . $price_point . '">Under $' . number_format($price_point) . '</a></td>';
							$first = false;
						}
						else if ($price_point == end($price_points)){
							echo '<td><a class="displet-price-navigation" displetminprice="' . $previous_price_point . '" displetmaxprice="999999999">Over $' . number_format($previous_price_point) . '</a></td>';
						}
						else{
							echo '<td><a class="displet-price-navigation" displetminprice="' . $previous_price_point . '" displetmaxprice="' . $price_point . '">$' . number_format($previous_price_point) . ' - $' . number_format($price_point) . '</a></td>';
						}
						$previous_price_point = $price_point;
						$i++;
					}
				?>
			</tr>
		</tbody>
	</table>
</div>