<script>
jQuery(document).ready(function($){
	var is_displet_api = <?php echo ($model['is_displet_api']) ? 'true' : 'false'; ?>;

	// Get query and hash param-value pairs and update search form elements
	var url_hash = window.location.hash;
	var hash_array = url_hash.replace('#', '').split('/');
	for (var i = hash_array.length - 1; i >= 0; i--) {
		var current_hash = hash_array[i].split('=');
		var current_parameter = current_hash[0];
		var current_value = current_hash[1];
		if ($('#displet-search-form input[name="' + current_parameter + '"][value="' + current_value + '"]').length) {
			$('#displet-search-form input[name="' + current_parameter + '"][value="' + current_value + '"]').attr('checked', 'checked');
		}
		else{
			$('#displet-search-form input[name="' + current_parameter + '"]').val(current_value);
		}
		$('#displet-search-form select[name="' + current_parameter + '"] option[value="' + current_value + '"]').attr('selected', true);
	};

	function displetReturnSearchResults(){
		// Get default query and update sort
		var current_query_url = '<?php echo $model["query_url"]; ?>';
		var last_sort = $.cookie('displet_last_viewed_listings_sort', {path: '/'});
		if (last_sort != undefined) {
			if (is_displet_api) {
				var sort_check = /[?&]priceSorter=([^&]+)/i;
			}
			else{
				var sort_check = /[?&]sort=([^&]+)/i;
			}
			var current_sort = current_query_url.match(sort_check);
		}
		if (last_sort != undefined && current_sort != undefined && last_sort != current_sort[0]){
			current_query_url = current_query_url.replace(sort_check, last_sort);
		}
		// Get hash param-value pairs
		var current_query_attributes = current_query_qs = price_min = price_max = square_feet_min = square_feet_max = '';
		var url_hash = window.location.hash;
		var hash_array = url_hash.replace('#', '').split('/');
		for (var i = hash_array.length - 1; i >= 0; i--) {
			var current_hash = hash_array[i].split('=');
			var current_parameter = current_hash[0];
			var current_value = current_hash[1];
			if (current_parameter != '' && current_value != '') {
				displetAddToQuery(current_parameter, current_value);
			}
		};

		// Build query
		function displetAddToQuery(parameter, value) {
			if (is_displet_api) {
				current_query_url += '&' + parameter + '=' + value;
			}
			else{
				var translated_array = displetTranslateParameter(new Array(parameter));
				if (translated_array[0] == 'attributes') {
					if (parameter == 'minListPrice') {
						price_min = value * 1000;
					}
					else if (parameter == 'maxListPrice') {
						price_max = value * 1000;
					}
					else if (parameter == 'minSquareFeet') {
						square_feet_min = value;
					}
					else if (parameter == 'maxSquareFeet') {
						square_feet_max = value;
					}
					else if (parameter == 'minBedrooms' || parameter == 'minBathrooms'){
						current_query_attributes += translated_array[1] + '_' + value + '+,';
					}
					else if (parameter == 'maxBedrooms' || parameter == 'maxBathrooms'){
						current_query_attributes += translated_array[1] + '_' + value + '-,';
					}
					else if (parameter == 'pool_on_property' && (value.toLowerCase() == 'y' || value.toLowerCase() == 'yes')) {
						current_query_attributes += 'amenities_' + translated_array[1] + ',';
					}
					else if (parameter == 'is_gated_community' && (value.toLowerCase() == 'y' || value.toLowerCase() == 'yes')) {
						current_query_attributes += 'amenities_' + translated_array[1] + ',';
					}
					else{
						current_query_attributes += translated_array[1] + '_' + value + ',';
					}
				}
				else if (translated_array[0] == 'q') {
					current_query_qs += value + ',';
				}
				else {
					if (translated_array[0] == 'location') {
						/* Prefers to have nationwide region instead of default if location is queried, but need to adapt for Canada
						if (current_query_url.indexOf('&region=') !== -1) {
							current_query_url = current_query_url.replace(/&region=(.*)&/, '&');
						}
						current_query_url += '&region=usa';
						*/
						current_query_url += '&radius=0';
					}
					else if (translated_array[0] == 'category') {
						// Remove current category
						if (current_query_url.indexOf('&category=') !== -1) {
							current_query_url = current_query_url.replace('&category=<?php echo $model["category"]; ?>', '');
						}
						// Translate value
						var current_category = '<?php echo $model["category"]; ?>';
						if (current_category == '') {
							current_category = 'housing/sale';
						}
						value = value.toLowerCase();
						if (value == 'house') {
							current_category += '/home';
						}
						else if (value == 'condo') {
							current_category += '/condo';
						}
						else if (value == 'commercial') {
							current_category += '/commercial';
						}
						else if (value == 'mobile') {
							current_category += '/mobile';
						}
						else if (value == 'vacation') {
							current_category += '/vacation';
						}
						else if (value == 'other') {
							current_category += '/other';
						}
						else if (value == 'open_house') {
							current_category += '/open_house';
						}
						else if (value == 'storage') {
							current_category += '/storage';
						}
						else if (value == 'land') {
							current_category = 'housing/sale/land';
						}
						else if (value == 'multi') {
							current_category = 'housing/sale/multi_family';
						}
						else if (value == 'ranch') {
							current_category = 'housing/sale/farm';
						}
						else if (value == 'lease') {
							current_category = 'housing/rent';
						}
						else if (value == 'apartment') {
							current_category = 'housing/rent/apartment';
						}
						else if (value == 'garage') {
							current_category = 'housing/rent/garage';
						}
						else if (value == 'roommates') {
							current_category = 'housing/rent/roommates';
						}
						else if (value == 'short_term') {
							current_category = 'housing/rent/short_term';
						}
						else if (translated_array[1] == 'foreclosure') {
							current_category = 'housing/sale/foreclosure';
						}
						value = current_category;
					}
					current_query_url += '&' + translated_array[0] + '=' + value;
				}
			}
		}

		// Translate parameters
		function displetTranslateParameter(parameter){
			if (parameter == 'minListPrice' || parameter == 'maxListPrice') {
				parameter = ['attributes', 'price'];
			}
			else if (parameter == 'minBedrooms' || parameter == 'maxBedrooms') {
				parameter = ['attributes', 'bedrooms'];
			}
			else if (parameter == 'minBathrooms' || parameter == 'maxBathrooms') {
				parameter = ['attributes', 'bathrooms'];
			}
			else if (parameter == 'minSquareFeet' || parameter == 'maxSquareFeet') {
				parameter = ['attributes', 'square_feet'];
			}
			else if (parameter == 'pool_on_property') {
				parameter = ['attributes', 'pool'];
			}
			else if (parameter == 'is_gated_community') {
				parameter = ['attributes', 'gated'];
			}
			else if (parameter == 'area' || parameter == 'zip' || parameter == 'area_mls_defined' || parameter == 'city') {
				parameter = ['location'];
			}
			else if (parameter == 'property_type') {
				parameter = ['category'];
			}
			else if (parameter == 'is_foreclosure') {
				parameter = ['category', 'foreclosure'];
			}
			else if (parameter == 'keyword' || parameter == 'quick_terms') {
				parameter = ['q'];
			}
			return parameter;
		}

		if (!is_displet_api) {
			// Handle min/max/range parameters
			if (price_min != '' && price_max != '') {
				current_query_attributes += 'price_' + price_min + '_' + price_max + ',';
			}
			else if (price_min != ''){
				current_query_attributes += 'price_' + price_min + '+' + ',';
			}
			else if (price_max != ''){
				current_query_attributes += 'price_' + price_max + '-' + ',';
			}
			if (square_feet_min != '' && square_feet_max != '') {
				current_query_attributes += 'square_feet_' + square_feet_min + '_' + square_feet_max + ',';
			}
			else if (square_feet_min != ''){
				current_query_attributes += 'square_feet_' + square_feet_min + '+' + ',';
			}
			else if (square_feet_max != ''){
				current_query_attributes += 'square_feet_' + square_feet_max + '-' + ',';
			}
		
			// Add attributes to query
			if (current_query_attributes != '') {
				current_query_url += '&attributes=' + current_query_attributes.slice(0,-1);
			}
		
			// Add qs to query
			if (current_query_qs != '') {
				current_query_url += '&q=' + current_query_qs.slice(0,-1);
			}
		}

		loadDispletAPIListings(current_query_url, is_displet_api);
		console.log(current_query_url, 'Displet Q');
		if (<?php echo !is_user_logged_in() ? 'true' : 'false'; ?>) {
			$.cookie('displet_last_searched_listings_hash', url_hash, {path:'/'});
		}
		else{
			var data = {
			    action: 'displet_update_user_hash',
			    _ajax_nonce: '<?php echo wp_create_nonce("displet_update_user_hash_nonce"); ?>',
			    last_hash: url_hash
			};
			$.post('<?php echo admin_url("admin-ajax.php"); ?>', data);
		}
	}
	displetReturnSearchResults();
	function displetAddSearchFormValuesToHash() {
		var hash = '#';
		$('#displet-search-form input[type="text"], #displet-search-form select, #displet-search-form input[type="radio"]:checked').each(function() {
			if (this.value != 'none' && this.value != '' && this.value != 'City, Zip, Neighborhood or Condo' && this.value != 'Keyword: Ex. Modern, Waterfront Etc') {
				hash += this.name + '=' + this.value.replace(' ', '%20') + '/';
			}
		});
		window.location.hash = hash;
	}
	$('#displet-search-form .displet-submit a').click(function(){
		displetAddSearchFormValuesToHash();
		displetReturnSearchResults();
	});
});
</script>