<?php

class DispletRetsIdxQuickSearchWidget extends WP_Widget {
	function DispletRetsIdxQuickSearchWidget() {
		// Instantiate the parent object
		parent::__construct(false, 'Displet Quick Search');
	}
	function widget( $args, $instance ) {
		// Widget output
		extract( $args );
        $title = empty($instance['title']) ? '' : apply_filters('widget_title', $instance['title']);

		// Retrieve options from settings page
		$displet_rets_idx_option = DispletRetsIdxSettings::get_option();
		$model = array(
			'color' => $displet_rets_idx_option['displet_rets_idx_option_color_scheme'],
			'quick_terms' => $displet_rets_idx_option['displet_rets_idx_option_quick_search_quick_terms'],
			'property_type' => $displet_rets_idx_option['displet_rets_idx_option_quick_search_property_type'],
			'price' => $displet_rets_idx_option['displet_rets_idx_option_quick_search_price'],
			'beds_baths' => $displet_rets_idx_option['displet_rets_idx_option_quick_search_beds_baths'],
			'keywords' => $displet_rets_idx_option['displet_rets_idx_option_quick_search_keywords'],
			'title' => $title
		);

        $displet_q_search_widget_content = DispletRetsIdxLoad::get_template('displet-quick-search-vertical.php', $model);
	    $displet_q_search_widget_output = $before_widget . $displet_q_search_widget_content . $after_widget;
		echo $displet_q_search_widget_output;
	}
	function update( $new_instance, $old_instance ) {
		// Save widget options
        return $new_instance;
	}
	function form( $instance ) {
		// Output admin widget options form
        $title = isset($instance['title']) ? strip_tags($instance['title']) : 'Search Properties';
        ?>
		<p>
			<label for="<?php echo $this->get_field_id('title'); ?>">Title: </label>
			<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo attribute_escape($title); ?>" />
		</p>
        <?php
	}
}

?>